Bug 586478 - GDB hangs when setting a breakpoint on a library not yet loaded
GDB hangs when setting a breakpoint on a library not yet loaded
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: gdb (Show other bugs)
13
All Linux
low Severity medium
: ---
: ---
Assigned To: Jan Kratochvil
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-04-27 13:24 EDT by Dodji Seketeli
Modified: 2011-02-02 15:38 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-02-02 15:38:29 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
First call stack (8.96 KB, text/plain)
2010-04-27 13:24 EDT, Dodji Seketeli
no flags Details
Second call stack taken after a longer hang/spinning period (9.06 KB, text/plain)
2010-04-27 13:25 EDT, Dodji Seketeli
no flags Details

  None (edit)
Description Dodji Seketeli 2010-04-27 13:24:28 EDT
Created attachment 409530 [details]
First call stack

The problem happened when I was trying to debug Nemiver, using gdb-7.0.1-44.fc12.x86_64 on Fedora 12. I tried to write a little reproducer using dlopen/dlsym, but it worked fine in that case.

So here is how you can get, compile, install Nemiver and reproduce the issue:

yum install yum-utils
yum-builddep nemiver
git clone git://git.gnome.org/git/nemiver nemiver.git
cd nemiver.git
export NEMIVER_DEVEL=on
./autogen.sh
make -j2
sudo make install
cd tests
gdb --args nemiver fooprog
b main
b nemiver::DBGPerspective::execute_program

Trying to set the second breakpoint hangs GDB. I debugged GDB a bit and I could get some call stacks that are attached below.
Comment 1 Dodji Seketeli 2010-04-27 13:25:53 EDT
Created attachment 409531 [details]
Second call stack taken after a longer hang/spinning period

I forgot to say that GDB hangs taking 100% CPU.
Comment 2 Dodji Seketeli 2010-04-27 13:31:55 EDT
Arg, I made a little mistake in the steps to reproduce. In the end I said:

b main
b nemiver::DBGPerspective::execute_program

It should rather be:

b main
run
b nemiver::DBGPerspective::execute_program

Sorry.
Comment 3 Sami Wagiaalla 2010-04-29 10:49:59 EDT
I am having trouble reproducing this, but I also cant match the line numbers from the stack trace to the source from the rpm. Is it possible that you have another version of gdb interfering with the system installed one ?
Comment 4 Bug Zapper 2010-11-03 12:10:43 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Bug Zapper 2010-12-03 10:22:08 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 6 Bug Zapper 2010-12-04 02:23:34 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 7 Bug Zapper 2010-12-05 01:20:47 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 8 Jan Kratochvil 2010-12-05 19:10:40 EST
Last verification has been done on f12.
Comment 9 Fedora Admin XMLRPC Client 2011-01-05 22:24:43 EST
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 10 Tom Tromey 2011-02-02 15:38:29 EST
(In reply to comment #1)
> Created attachment 409531 [details]
> Second call stack taken after a longer hang/spinning period
> 
> I forgot to say that GDB hangs taking 100% CPU.

Based on the stack trace, I would say that this has been fixed a
long time ago.  In the 7.0 time frame there was a bug where some
kinds of namespace lookup took a lot of CPU.  This was fixed in
7.1, IIRC.

I am closing this on that basis.
If you can still reproduce it with a newer gdb, please reopen
and I will take a look.

Note You need to log in before you can comment on or make changes to this bug.